"use strict";

var compareSnapshotCommand = function compareSnapshotCommand(defaultScreenshotOptions) {
  Cypress.Commands.add('compareSnapshot', {
    prevSubject: 'optional'
  }, function (subject, name) {
    var screenshotOptions = defaultScreenshotOptions; // take snapshot

    var objToOperateOn = subject ? cy.get(subject) : cy;
    objToOperateOn.screenshot(name, screenshotOptions).task('copyScreenshot', {
      testName: name
    }); // run visual tests

    var options = {
      testName: name
    };
    cy.task('compareSnapshotsPlugin', options).then(function (result) {
      if (result > 0) {
        throw new Error("The image has ".concat(result, " pixel differences."));
      }
    });
  });
};

module.exports = compareSnapshotCommand;